# Generated by Django 3.1.3 on 2020-11-20 11:21
import os

import magic
from django.conf import settings
from django.db import migrations, models


def source_path(self):
    if self.filename:
        fname = str(self.filename)
    else:
        fname = "{:07}.{}".format(self.pk, self.file_type)
        if self.storage_type == self.STORAGE_TYPE_GPG:
            fname += ".gpg"

    return os.path.join(
        settings.ORIGINALS_DIR,
        fname
    )


def add_mime_types(apps, schema_editor):
    Document = apps.get_model("documents", "Document")
    documents = Document.objects.all()

    for d in documents:
        d.mime_type = magic.from_file(source_path(d), mime=True)
        d.save()


class Migration(migrations.Migration):

    dependencies = [
        ('documents', '1002_auto_20201111_1105'),
    ]

    operations = [
        migrations.AddField(
            model_name='document',
            name='mime_type',
            field=models.CharField(default="-", editable=False, max_length=256),
            preserve_default=False,
        ),
        migrations.RunPython(add_mime_types),
        migrations.RemoveField(
            model_name='document',
            name='file_type',
        ),
    ]
